
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# paivystys tarkastusfunktiot

function paivystys_ok(&$msg,$id,$nimi,$oletus_verkko_id) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # tarpeelliset kentt
  if ($nimi == '') {
    $msg = 'Operaation nimi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # verkko oltava olemassa
  if (tab_col_id("verkko","",$oletus_verkko_id) == '') {
    $msg = "Verkkoa $oletus_verkko_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE nimi = '$nimi'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen operaatio on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function paivystys_add_ok(&$msg,$nimi,$oletus_verkko_id) {
  return paivystys_ok($msg,'',$nimi,$oletus_verkko_id);
}

function paivystys_save_ok(&$msg,$id,$nimi,$oletus_verkko_id) {
  return paivystys_ok($msg,$id,$nimi,$oletus_verkko_id);
}

function paivystys_id_ok(&$msg,$id) {
  global $table;
  
  $msg = '';
  
  if ($id == '') {
    $msg = "Tuntematon operaatio.";
    return 2;
  }

  # oltava olemassa
  if (tab_col_id("paivystys","id",$id) == '') {
    $msg = "Operaatiota $id ei lydy.";
    return 2;
  }
  
  return 0;
}

function paivystys_remove_ok(&$msg,$id) {
  $msg = '';
  $ret = 0;

  # operaatiota 1 ei voi poistaa
  if ($id == 1) {
    $msg = "Operaatiota numero 1 ei voi poistaa.";
    return 2;
  }

  # jos operaatioon on viittauksia kyttjiss, paikoissa, ryhma_tiloissa,
  # ryhmiss, jrjestiss, hlo_tiloissa, henkiliss, kadonneissa, lytyneiss,
  # lokeissa, laitteissa tai tavaroissa
  # sit ei voi poistaa
  $ref = ota_yksi("SELECT COUNT(*) FROM kayttajat WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri kyttjsss.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM paikka WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri sijainnissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM ryhma_tila WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri ryhmn tilakoodissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM ryhma WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri ryhmn tiedoissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM jarjesto WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri jrjestss.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM hlo_tila WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri henkiln tilakoodissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM hlo WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref eri henkiln tiedoissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM kadonnut WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref kadonneen tiedoissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM loytynyt WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on viittauksia $ref lytyneen tiedoissa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM loki WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on $ref viittausta teknisess lokissa.";
    $ret = 2;
  }
  $ref =
    ota_yksi("SELECT COUNT(*) FROM taktinen_loki WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= " Thn operaatioon on $ref viittausta tapahtumapivkirjassa.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM laite WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= "Thn operaatioon on viittauksia $ref viestivlineess.";
    $ret = 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM tavara WHERE paivystys_id = $id");
  if ($ref != 0) {
    $msg .= "Thn operaatioon on viittauksia $ref tavarassa.";
    $ret = 2;
  }

  if ($ret == 2) {
    $msg .= " Sit ei voi poistaa ennen kuin viittaukset on siivottu.";
  }
  return $ret;
}

?>

<!-- RCS $Id: paivystys-ok.php,v 1.3 2009/02/05 07:20:05 riku Exp $ -->
