
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# ryhna_tila tarkastusfunktiot

function ryhma_tila_ok(&$msg,$id,$paivystys_id,$ryhma_tila) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if (($id == "1") || ($id == "2") || ($id == "8") || ($id == "11") ||
      ($id == "12")) {
    $msg = "Koodit numero 1, 2, 8, 11 ja 12 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($ryhma_tila == '') {
    $msg = 'Tilakoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # suojaus
  if ($modify) {
    if (tab_col_id("ryhma_tila","suojattu",$id) == 1) {
      $msg = "Tm tietue on suojattu.";
      $msg .= $tail;
      return 2;
    }
  }

  # paivystyksen oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE ryhma_tila = '$ryhma_tila'
      AND ((paivystys_id = $_SESSION[paivystys]) OR (paivystys_id = 0))
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function ryhma_tila_add_ok(&$msg,$paivystys_id,$ryhma_tila) {
  return ryhma_tila_ok($msg,'',$paivystys_id,$ryhma_tila);
}

function ryhma_tila_save_ok(&$msg,$id,$paivystys_id,$ryhma_tila) {
  return ryhma_tila_ok($msg,$id,$paivystys_id,$ryhma_tila);
}

function ryhma_tila_remove_ok(&$msg,$id) {
  $msg = '';

  # kovakoodatut tietueet
  if (($id == "1") || ($id == "2") || ($id == "8") || ($id == "11") ||
      ($id == "12")) {
    $msg = "Koodit numero 1, 2, 8, 11 ja 12 on suojattu.";
    return 2;
  }

  # suojattua ei voi poistaa
  if (tab_col_id("ryhma_tila","suojattu",$id) == 1) {
    $msg = "Tm tietue on suojattu. Ei voi poistaa.";
    return 2;
  }

  # jos hlo_tilaan on viittauksia henkiliss
  # sit ei voi poistaa
  $ref = ota_yksi("
SELECT COUNT(*)
FROM ryhma
WHERE ryhma_tila_id = $id
");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri ryhmss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: ryhma_tila-ok.php,v 1.2 2009/02/05 16:48:31 riku Exp $ -->
