
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# tavara tarkastusfunktiot
# HUOM: ryhma_id vlitetn viittauksena koska sit voidaan joutua muuttamaan

function tavara_ok(&$msg,$id,$paivystys_id,$jarjesto_id,$hlo_id,$tavara,
		   $tunniste,&$ryhma_id,$tavara_tyyppi_id) {
  global $table;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # tarpeelliset kentt
  if (($jarjesto_id == 1) && ($hlo_id == 0)) {
    $msg = 'Kalustolla on oltava omistaja, joko henkil tai jrjest tai
 molemmat. ';
    $msg .= $tail;
    return 2;
  }

  if ($tavara == '') {
    $msg = 'Kuvaus on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystys, jarjesto, hlo, ryhma ja tavara_tyyppi oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("jarjesto","",$jarjesto_id) == '') {
    $msg = "Jrjest $jarjesto_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id_nobody("hlo","nimi",$hlo_id) == '') {
    $msg = "Henkil $hlo_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("tavara_tyyppi","",$tavara_tyyppi_id) == '') {
    $msg = "Kalustotyyppi $tavara_tyyppi_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE jarjesto_id = $jarjesto_id AND hlo_id = $hlo_id
      AND tavara = '$tavara' AND tunniste = '$tunniste'
      AND tavara_tyyppi_id = $tavara_tyyppi_id
      $id_sql
");
  if ($dup != '') {
    $msg = 'Saman omistajan kaluston on oltava yksilllist, eli vhintn
tunnisteiden on erottava toisistaan.';
    if ($modify) {
      $msg .= " Tllainen tavara on jo olemassa (id=$dup).";
    }
    $msg .= $tail;
    return 2;
  } 

  # jos ryhma ja paivystys on asetettu, niiden tytyy tsmt mod 0.
  if (($ryhma_id != '1') && ($paivystys_id != '0')) {
    if (tab_col_id("ryhma","paivystys_id",$ryhma_id) != $paivystys_id) {
      $msg = "Annetut ryhm($ryhma_id) ja operaatio($paivystys_id) eivt
 sovi yhteen. Ryhm palautettu oletustilaan.";
      $ryhma_id = 1;
      $ret = 1;
    }
  }
  
  return $ret;
}

function tavara_add_ok(&$msg,$paivystys_id,$jarjesto_id,$hlo_id,$tavara,
		       $tunniste,&$ryhma_id,$tavara_tyyppi_id) {
  return tavara_ok($msg,'',$paivystys_id,$jarjesto_id,$hlo_id,$tavara,
		   $tunniste,$ryhma_id,$tavara_tyyppi_id);
}

function tavara_save_ok(&$msg,$id,$paivystys_id,$jarjesto_id,$hlo_id,$tavara,
			$tunniste,&$ryhma_id,$tavara_tyyppi_id) {
  return tavara_ok($msg,$id,$paivystys_id,$jarjesto_id,$hlo_id,$tavara,
		   $tunniste,$ryhma_id,$tavara_tyyppi_id);
}

function tavara_remove_ok(&$msg,$id) {
  # XXX voi olla kiinni operaatiossa?
  return 0;
}

?>

<!-- RCS $Id: tavara-ok.php,v 1.1 2009/01/31 10:57:40 riku Exp $ -->
