<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# tavara_tyyppi tarkastusfunktiot

function tavara_tyyppi_ok(&$msg,$id,$tavara_tyyppi) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Koodi numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($tavara_tyyppi == '') {
    $msg = 'Tyyppikoodi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE tavara_tyyppi = '$tavara_tyyppi'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen koodi on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function tavara_tyyppi_add_ok(&$msg,$tavara_tyyppi) {
  return tavara_tyyppi_ok($msg,'',$tavara_tyyppi);
}

function tavara_tyyppi_save_ok(&$msg,$id,$tavara_tyyppi) {
  return tavara_tyyppi_ok($msg,$id,$tavara_tyyppi);
}

function tavara_tyyppi_remove_ok(&$msg,$id) {
  $msg = '';

  # kovakoodattu
  if ($id == "1") {
    $msg = "Koodia numero 1 ei voi poistaa.";
    return 2;
  }

  # jos tavara_tyyppiin on viittauksia kalustossa
  # sit ei voi poistaa
  $ref = ota_yksi("
SELECT COUNT(*)
FROM tavara
WHERE tavara_tyyppi_id = $id
");
  if ($ref != 0) {
    $msg = "Thn koodiin on viittauksia $ref eri tavarassa. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: tavara_tyyppi-ok.php,v 1.3 2009/02/05 16:51:03 riku Exp $ -->
